# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetUpdateWindowsResult',
    'AwaitableGetUpdateWindowsResult',
    'get_update_windows',
    'get_update_windows_output',
]

@pulumi.output_type
class GetUpdateWindowsResult:
    """
    A collection of values returned by getUpdateWindows.
    """
    def __init__(__self__, id=None, name=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")


class AwaitableGetUpdateWindowsResult(GetUpdateWindowsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetUpdateWindowsResult(
            id=self.id,
            name=self.name)


def get_update_windows(name: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetUpdateWindowsResult:
    """
    The `UpdateWindows` data source allows the OneAgent update maintenance window ID to be retrieved by its name.

    - `name` (String) - The name of the OneAgent update maintenance window

    ## Example Usage

    ```python
    import pulumi
    import pulumi_dynatrace as dynatrace

    example = dynatrace.get_update_windows(name="Terraform Example")
    pulumi.export("id", example.id)
    ```
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('dynatrace:index/getUpdateWindows:getUpdateWindows', __args__, opts=opts, typ=GetUpdateWindowsResult).value

    return AwaitableGetUpdateWindowsResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'))
def get_update_windows_output(name: Optional[pulumi.Input[str]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetUpdateWindowsResult]:
    """
    The `UpdateWindows` data source allows the OneAgent update maintenance window ID to be retrieved by its name.

    - `name` (String) - The name of the OneAgent update maintenance window

    ## Example Usage

    ```python
    import pulumi
    import pulumi_dynatrace as dynatrace

    example = dynatrace.get_update_windows(name="Terraform Example")
    pulumi.export("id", example.id)
    ```
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('dynatrace:index/getUpdateWindows:getUpdateWindows', __args__, opts=opts, typ=GetUpdateWindowsResult)
    return __ret__.apply(lambda __response__: GetUpdateWindowsResult(
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name')))
